#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "support.h"
#include "version.h"
#include "engine.h"
#include <string.h>

extern GtkWidget *about;
extern GtkWidget *mainwindow;

static char *id = "@(#) $Id: callbacks.c 2408 2011-08-24 12:24:45Z lyonel $";

G_MODULE_EXPORT
void
refresh_display                        (GtkMenuItem     *menuitem,
gpointer         user_data)
{
  refresh(mainwindow);
}


G_MODULE_EXPORT
void
on_about1_activate                     (GtkMenuItem     *menuitem,
gpointer         user_data)
{
  if(GTK_IS_WIDGET(about))
  {
    gtk_widget_show(about);
  }
}


G_MODULE_EXPORT
void
on_aboutclose_activate          (GtkButton       *button,
gpointer         user_data)
{
  if(GTK_IS_WIDGET(about))
  {
    gtk_widget_hide(about);
  }
}


G_MODULE_EXPORT
void
on_version_realize                     (GtkWidget       *widget,
gpointer         user_data)
{
  gtk_label_set_text(GTK_LABEL(widget), getpackageversion());
}


G_MODULE_EXPORT
void
on_treeview1_row_activated             (GtkTreeView     *treeview,
GtkTreePath     *path,
GtkTreeViewColumn *column,
gpointer         user_data)
{
  browse(1, treeview);
}


G_MODULE_EXPORT
void
on_treeview2_row_activated             (GtkTreeView     *treeview,
GtkTreePath     *path,
GtkTreeViewColumn *column,
gpointer         user_data)
{
  browse(2, treeview);
}


G_MODULE_EXPORT
void
on_treeview3_row_activated             (GtkTreeView     *treeview,
GtkTreePath     *path,
GtkTreeViewColumn *column,
gpointer         user_data)
{
  browse(3, treeview);
}


G_MODULE_EXPORT
void
on_treeview1_cursor_changed            (GtkTreeView     *treeview,
gpointer         user_data)
{
  change_selection(1, treeview);
}


G_MODULE_EXPORT
void
on_treeview2_cursor_changed            (GtkTreeView     *treeview,
gpointer         user_data)
{
  change_selection(2, treeview);
}


G_MODULE_EXPORT
void
on_treeview3_cursor_changed            (GtkTreeView     *treeview,
gpointer         user_data)
{
  change_selection(3, treeview);

  (void) &id;                                     // avoid warning "id defined but not used"
}


G_MODULE_EXPORT
void
go_up                                  (GtkToolButton   *toolbutton,
gpointer         user_data)
{
  go_back(mainwindow);
}


G_MODULE_EXPORT
void
on_lshw_map                            (GtkWidget       *widget,
gpointer         user_data)
{
  refresh(mainwindow);
}

G_MODULE_EXPORT
void
on_save_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  save_as(mainwindow);
}


G_MODULE_EXPORT
void
on_savebutton_clicked                  (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
  on_save_activate(NULL, NULL);
}

